/*
 * basicCharDD.c
 */
#include <linux/init.h>
#include <linux/module.h>
#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/fcntl.h>

MODULE_LICENSE("Dual BSD/GPL");

#define BASIC_CHAR_DD_MAJOR_NUMBER   255
#define BASIC_CHAR_DD_DEVICE_NAME    "basic_char_device"

// int (*open) (struct inode *, struct file *);
int basic_char_open(struct inode *inode, struct file * file_p)
{
    printk("[DEV] basic_char_open() major:%d, minor:%d\n", MAJOR(inode->i_rdev), MINOR(inode->i_rdev));
    return 0;
}

// ssize_t (*read) (struct file *, char __user *, size_t, loff_t *);
ssize_t basic_char_read(struct file * file_p, char __user * buffer_p,
                            size_t count, loff_t * offset_p)
{
    printk("[DEV] basic_char_read() buffer_p:%x, count:%x\n", (int)buffer_p, count);
    return 0;
}

// ssize_t (*write) (struct file *, const char __user *, size_t, loff_t *);
ssize_t basic_char_write(struct file * file_p, const char __user * buffer_p,
                             size_t count, loff_t * offset_p)
{
    printk("[DEV] basic_char_write() buffer_p:%x, count:%x\n", (int)buffer_p, count);
    return 0;
}

// int (*ioctl) (struct inode *, struct file *, unsigned int, unsigned long);
int basic_char_ioctl(struct inode * inode_p, struct file * file_p,
                        unsigned int command, unsigned long argument)
{
    printk("[DEV] basic_char_ioctl() command:%x, argument:%x\n", command, (int)argument);
    return 0;
}

// int (*release) (struct inode *, struct file *);
int basic_char_release(struct inode * inode_p, struct file * file_p)
{
    printk("[DEV] basic_char_release()\n");
    return 0;
}

struct file_operations basic_char_file_oper =
{
        .owner =THIS_MODULE,
        .open = basic_char_open,
        .read=basic_char_read,
        .write=basic_char_write,
        .ioctl=basic_char_ioctl,
        .release=basic_char_release,
};

static int basic_char_init(void)
{
    printk("[DEV] basic_char_init() is called.\n");
    return register_chrdev(BASIC_CHAR_DD_MAJOR_NUMBER,
                             BASIC_CHAR_DD_DEVICE_NAME, &basic_char_file_oper);
}

static void basic_char_exit(void)
{
    printk("[DEV] basic_char_exit() is called.\n");
    unregister_chrdev(BASIC_CHAR_DD_MAJOR_NUMBER,BASIC_CHAR_DD_DEVICE_NAME);
}

module_init(basic_char_init);
module_exit(basic_char_exit);
