/*
 * basicCharDD.c
 */
#include <linux/init.h>
#include <linux/module.h>
#include <linux/fs.h>

MODULE_LICENSE("Dual BSD/GPL");

#define BASIC_CHAR_DD_MAJOR_NUMBER   255
#define BASIC_CHAR_DD_DEVICE_NAME    "basic_char_device"

struct file_operations basic_char_file_oper;

static int basic_char_init(void)
{
    printk("basic_char_init() is called.\n");
    return register_chrdev(BASIC_CHAR_DD_MAJOR_NUMBER,
                           BASIC_CHAR_DD_DEVICE_NAME, &basic_char_file_oper);
}

static void basic_char_exit(void)
{
    printk("basic_char_exit() is called.\n");
    unregister_chrdev(BASIC_CHAR_DD_MAJOR_NUMBER,BASIC_CHAR_DD_DEVICE_NAME);
}

module_init(basic_char_init);
module_exit(basic_char_exit);

