#include <jni.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>

#define MANGO64_LED_DEVICE_NAME   "/dev/mango64_led_device"

static int g_mango64_led_dev = -1;

jint Java_com_crz_mango64LED_mango64LedApp_Mango64LedOpen(JNIEnv * env, jobject thiz)
{
    printf("[NDK_LIB] mango64 LED device open start\n");
    g_mango64_led_dev = open(MANGO64_LED_DEVICE_NAME, O_RDWR|O_NDELAY);
    if(g_mango64_led_dev < 0)
    {
        printf("[NDK_LIB] mango64 LED open error, dev:%d\n", g_mango64_led_dev);
        return -1;
    }
    printf("[NDK_LIB] mango64 LED open success, dev:%d\n", g_mango64_led_dev);
    return 0;
}

jint Java_com_crz_mango64LED_mango64LedApp_Mango64LedClose(JNIEnv * env, jobject thiz)
{
    printf("[NDK_LIB] device file close start\n");
    close(g_mango64_led_dev);
    g_mango64_led_dev = -1;
    printf("[NDK_LIB] device file close end\n");
    return 0;
}

jint Java_com_crz_mango64LED_mango64LedApp_Mango64LedControl(JNIEnv * env, jobject thiz, jint ledNum, jint ledOnOff)
{
    printf("[NDK_LIB] mango64 LED %d OnOff %d\n", ledNum, ledOnOff);
    if(g_mango64_led_dev < 0)
    {
        printf("[NDK_LIB] mango64 LED dev error, dev:%d\n", g_mango64_led_dev);
        return -1;
    }
    return (jint)(ioctl(g_mango64_led_dev, ledNum, ledOnOff));
}

