package com.crz.mango64LED;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

public class mango64LedApp extends Activity {
	private int clickState_led1 = 1;
	private int clickState_led2 = 1;

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
       
        final Button bt1 = (Button)findViewById(R.id.Button01);
        bt1.setOnClickListener(new View.OnClickListener(){
        	public void onClick(View v) {
        		clickState_led1 ^= 0x1;
        		if(0 == clickState_led1){
        			Mango64LedControl(1, 0);
        			bt1.setText(R.string.led1Off);
        		}else{
        			Mango64LedControl(1, 1);
        			bt1.setText(R.string.led1On);
        		}
        	}
        });

        final Button bt2 = (Button)findViewById(R.id.Button02);
        bt2.setOnClickListener(new View.OnClickListener(){
        	public void onClick(View v) {
        		clickState_led2 ^= 0x1;
        		if(0 == clickState_led2){
        			Mango64LedControl(2, 0);
        			bt2.setText(R.string.led2Off);
        		}else{
        			Mango64LedControl(2, 1);
        			bt2.setText(R.string.led2On);
        		}
        	}
        }); 

        Mango64LedOpen();
    }

	@Override
	protected void onDestroy() {
		Mango64LedClose();
		super.onDestroy();
	}

	public native int Mango64LedOpen();
	public native int Mango64LedClose();
	public native int Mango64LedControl(int ledNum, int ledOnOff);

	public native int unimplementedMango64LedOpen();
	public native int unimplementedMango64LedClose();
	public native int unimplementedMango64LedControl(int ledNum, int ledOnOff);

    static {
        System.loadLibrary("mango64LED_lib");
    }
}