#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>

#define MANGO64_LED_DEVICE_NAME   "/dev/mango64_led_device"

int main(void)
{
    int dev;
    int ioctl_retval;

    printf("[APP] mango64 LED device open start\n");
    dev = open(MANGO64_LED_DEVICE_NAME, O_RDWR|O_NDELAY);
    if(dev < 0)
    {
        printf("[APP] mango64 LED open error, dev:%d\n", dev);
        return -1;
    }
    printf("[APP] mango64 LED device open success: %d\n", dev);

    getchar();
    printf("[APP] mango64 LED 1 Off\n");
    ioctl(dev, 0x1, 0x0);

    getchar();
    printf("[APP] mango64 LED 2 Off\n");
    ioctl(dev, 0x2, 0x0);

    getchar();
    printf("[APP] mango64 LED 1 On\n");
    ioctl(dev, 0x1, 0x1);

    getchar();
    printf("[APP] mango64 LED 2 On\n");
    ioctl(dev, 0x2, 0x1);

    getchar();
    ioctl_retval = ioctl(dev, 0x3, 0x3);
    printf("[APP] mango64 LED Error IOCTL retVal:%d\n", ioctl_retval);

    printf("[APP] device file close start\n");
    close(dev);
    printf("[APP] device file close end\n");
    return 0;
}
